{-# LANGUAGE CPP #-}
{-------------------------------------------------------------------------------

        Copyright:              Bernie Pope 2004

        Module:                 Help

        Description:            Print a help message regarding the use of
                                baskell's command line.

        Primary Authors:        Bernie Pope

-------------------------------------------------------------------------------}

{-
    This file is part of baskell.

    baskell is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    baskell is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with baskell; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-}

module Help
   ( printHelp )
   where

--------------------------------------------------------------------------------

printHelp :: IO ()
printHelp
   = do putStrLn "Commands available from the prompt:"
        putStrLn ":b              = show types of defined functions"
        putStrLn ":h              = show this help message"
        putStrLn ":l '<filename>' = load a baskell file, quotes are needed around the name (defaults are usually in /usr/share/baskell...)"
        putStrLn ":q              = quit"
        putStrLn ":t <exp>        = show the type of an expression"
        putStrLn "<exp>           = evaluate an expression"
#ifdef DEBUG
        putStrLn ":ast            = show the abstract syntax tree"
        putStrLn ":depend         = show function dependencies"
#endif
